<?php
/*
Plugin Name: Raindrops helper
Plugin URI: http://www.tenman.info/wp3/raindrops-helper/
Description:Raindrops theme helper plugin
Version: 0.1
Author:Akio Tenman
Author URI: http://www.tenman.info/
*/

if (isset($wp_version)) {
    add_filter("mce_buttons", "extended_editor_mce_buttons", 0);
    add_filter("mce_buttons_2", "extended_editor_mce_buttons_2", 0);
    //add_filter("mce_buttons_3", "extended_editor_mce_buttons_3", 0);
}

function extended_editor_mce_buttons($buttons) {
    $mce_buttons = array(
    "undo", "redo","newdocument","wp_more",'wp_page',
    "bold", "italic", "separator",
    "bullist", "link", "separator",
    "formatselect", 'fullscreen', "search", "replace", "wphelp",'wp_adv','wp_adv_start');
    return $mce_buttons;
}

function extended_editor_mce_buttons_2($buttons) {
// the second toolbar line
    $mce_buttons = array(
    'formatselect', 'forecolor', 'backcolor','separator',
    'hr','underline','strikethrough','separator',
    'justifyleft','justifycenter','justifyright','justifyfull','outdent','indent','separator',
    'cut', 'copy', 'paste','removeformat','cleanup','separator','charmap');
    return $mce_buttons;

        }
function extended_editor_mce_buttons_3($buttons) {
    return array('wp_adv_end');
}

add_action('init', 'raindrops_addbuttons');

function raindrops_addbuttons(){
if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;

   // Add only in Rich Editor mode
   if ( get_user_option('rich_editing') == 'true') {
        add_filter('mce_external_plugins', "raindrops_editor_button_register");
        add_filter('mce_buttons', 'raindrops_editor_add_button', 0);
    }

}

function raindrops_editor_add_button($button){
    array_push($button, "addMyButton");
    return $button;
}

function raindrops_editor_button_register($plugin_array){

	$x = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
    $plugin_array['addMyButton'] = $x.'raindrops-helper.js';
    return $plugin_array;
}



/**
 * Functions for shortcodes
 *
 */

/**
 * shortcode content clean up
 *
 */

    add_filter('the_content','raindrops_remove_para',99);

    function raindrops_remove_para($content){
        $target = array("|<p>(</?div)|u",'|(</?div[^<]+)</p>|','|(</?h3[^<]+)</p>|');
        $change = array("$1", "$1","$1");
        $content = preg_replace($target,$change,$content);
        return $content;
    }

/**
 * dialog shortcode
 *
 * return value e.g.<div class="gradient3 raindrops-dialog" style="[attr style]"><h3 class="gradient-2 raindrops-dialog-title" style="margin: 0; padding: 0.2em 1em;">[attr title]</h3><div class="raindrops-dialog-content pad-m">[content]</div></div>
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('dialog', 'raindrops_dialog_shortcode');

    function raindrops_dialog_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'title' => 'title',
           'style' => 'min-height: 100px;'
           ), $atts ) );

        return '<div class="gradient3 raindrops-dialog" style="'.$style.'"><h3 class="gradient-2 raindrops-dialog-title" style="margin: 0; padding: 0.2em 1em;">'.$title.'</h3><div class="raindrops-dialog-content pad-m">'.$content.'</div></div>';
    }
/**
 * Tab shortcode
 *
 * return value e.g.<div class="raindrops-tab"><ul class="raindrops-tab-list clearfix"><li class="dummy">Tab Area</li></ul><div class="raindrops-tab-content clearfix  [attr class]" >[content]</div></div>
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('tab', 'raindrops_tab_shortcode');
    add_shortcode('tab_item', 'raindrops_tab_content_shortcode');

    /*check br ploblem  now stylesheet display:none;*/
    function raindrops_tab_shortcode( $atts, $content = null ) {
            extract( shortcode_atts( array(
           'title' => 'title',
           'class' => '',
           'before' => '<div class="raindrops-tab"><ul class="raindrops-tab-list clearfix"><li class="dummy">Tab Area</li></ul><div class="raindrops-tab-content clearfix  %1$s" >',
           'after' => '</div></div>'
           ), $atts ) );

            $before = sprintf($before, $class);
            $content = trim($content);

        return $before. do_shortcode(shortcode_unautop($content)) . $after;
    }

/**
 * Tab content shortcode
 *
 * return value e.g. <div class="raindrops-tab-page"><h3>[attr title]</h3>[content]</div>
 *
 * @param array()
 * @return string html block
 */

    function raindrops_tab_content_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'title' => 'title',
           ), $atts ) );

           return '<div class="raindrops-tab-page"><h3>'.$title.'</h3>'. do_shortcode(shortcode_unautop($content)) . '</div>';
    }

/**
 * Toggle shortcode
 *
 *
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('toggle', 'raindrops_toggle_shortcode');

    function raindrops_toggle_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'title' => 'title',
           'class_title' => '',
           'class_content' => ''
           ), $atts ) );

           $result = sprintf('<ul><li class="raindrops-toggle raindrops-toggle-title '.$class_title.'">'.$title.'</li><li class="raindrops-toggle '.$class_content.'">'.do_shortcode(shortcode_unautop($content)).'</li></ul>');

           return $result;

    }
/**
 * Entry divides shortcode
 *
 * It divides entry. Special grid, 2/3 - 1/3
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('bar_right_m', 'raindrops_bar_right_middle');
    function raindrops_bar_right_middle( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-gc %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode
 *
 * It divides entry. Special grid, 3/4 - 1/4
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('bar_right_s', 'raindrops_bar_right_narrow');
    function raindrops_bar_right_narrow( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-ge %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode
 *
 * It divides entry. Special grid, 1/3 - 2/3
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('bar_left_m', 'raindrops_bar_left_middle');
    function raindrops_bar_left_middle( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-gd %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode
 *
 * It divides entry. Special grid, 1/4 - 3/4
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('bar_left_s', 'raindrops_bar_left_narrow');
    function raindrops_bar_left_narrow( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-gf %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode
 *
 * It divides entry. Standard half grid
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('bar_harf', 'raindrops_bar_harf_shortcode');
    function raindrops_bar_harf_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-g %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode
 *
 * It divides entry.  - Special grid, 1/3 - 1/3 - 1/3
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('bar_3', 'raindrops_bar_3_shortcode');
    function raindrops_bar_3_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-gb %1$s">%2$s</div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode content
 *
 * first content
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('col1', 'raindrops_div_left_shortcode');

    function raindrops_div_left_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-u first"><div class=" %1$s">%2$s</div></div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode content
 *
 * second content
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('col2', 'raindrops_div_right_shortcode');

    function raindrops_div_right_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-u"><div class=" %1$s">%2$s</div></div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }
/**
 * Entry divides shortcode content
 *
 * third content only use bar_3
 *
 * @param array()
 * @param string
 * @return string html block
 */

    add_shortcode('col3', 'raindrops_div_center_shortcode');
    function raindrops_div_center_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'class' => '',
           ), $atts ) );

           $result = sprintf('<div class="yui-u"><div class=" %1$s">%2$s</div></div>',$class,do_shortcode(shortcode_unautop($content)));

           return $result;
    }


/**
 * Custom field shortcode
 *
 * display custom field value
 *
 * @param array()
 * @param string
 * @return string html block
 */
    add_shortcode('custom_field', 'raindrops_custom_field_shortcode');

    function raindrops_custom_field_shortcode( $atts, $content = null ) {
        extract( shortcode_atts( array(
           'name' => '',
           'fallback' => '',
           'class' => '',
           'before' => '<%1$s class="custom-field-shortcode %2$s">',
           'after' => '</%s>',
           'element' => 'div'
           ), $atts ) );

          $keys = get_post_custom_keys();
          $before = sprintf($before,$element,$class);
          $after = sprintf($after,$element);
          if(in_array($name,$keys,true)){
            return $before.post_custom($name).$after;
          }else{
            return $before.$fallback.$after;
          }
    }

/**
 * Slideshow needs this html struct
 * must needs id="slides" and class="slides_container"
<div id="slides">
  <div class="slides_container">
  <div>
  <h1>Slide 1</h1>
  <p>
  Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
  </p>
  </div>
  <div>
  <h1>Slide 2</h1>
  <p>
  Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
  </p>
  </div>
  <div>
  <h1>Slide 3</h1>
  <p>
  Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
  </p>
  </div>
  <div>
  <h1>Slide 4</h1>
  <p>
  Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
  </p>
  </div>
  </div>
</div>
 *
 *
 */
/**
 * Slideshow script include or not
 *
 *
 *
 *
 */
	
	add_action("wp_head","raindrops_add_slides");
	
	function raindrops_add_slides(){
	?>
<script type="text/javascript">
jQuery(function(){

	jQuery('#slides').slides({

				preload: true,
				play: 5000,
				pause: 2500,
				hoverPause: true

	});

});

</script>
<?php	
	}
/* add jquery slider js*/
			$raindrops_slides    = plugins_url('slides.min.jquery.js',__FILE__);
			
            wp_register_script('raindrops_slides', $raindrops_slides,array('jquery'),$raindrops_version,false);
			
            wp_enqueue_script('raindrops_slides');


/**
 *
 *
 *
 *
 *
 */

	add_action('edit_post','raindrops_add_revision');

	function raindrops_add_revision($id){
	
		$before 		= array("&amp;","&gt;","&lt;","&nbsp;","&quot;");
		$after 			= array("&",">","<","",'"');
		
		$args = array( 
			'post_parent' => $id,
			'post_type'   => 'revision', 
			'numberposts' => -1,
			
		);
		
		$revision 	= &get_children( $args);
		$revision 	= array_shift($revision);
		$revision 	= $revision->post_content;
			
		$status 	= get_post( $id, 'OBJECT', 'attribute' );
		$status 	= $status->post_status;
		
		
		if(mb_strlen($revision,'UTF-8') > 1400){
		
		update_post_meta($id, "revision",get_post_status($id).','.mb_strlen($content,'UTF-8')."Too many characters.");
		return;
		}

		$revision		= preg_replace('!\[[^\]]+\]!','',$revision);
		$revision 		= str_replace($before,$after, $revision);
		$revision		= strip_tags($revision);
		
		$new 			= htmlspecialchars($_POST["content"]);
		$new			= preg_replace('!\[[^\]]+\]!','',$new);
		$new			= str_replace($before,$after, $new);
		$new 			= strip_tags($new);

		$diff 			= strip_tags(wp_text_diff($revision,$new));
		$diff 			= str_replace(array("&lt;","&gt;",'+'),array("<",">","\n+"),$diff);
		
		$points			= explode("\n",$diff);
		$result 		= "";
		
		foreach($points as $change){
		
			if(preg_match("!^(-.+$|\+.+$)!",$change,$regs)){
			
				$result .= "\n".$regs[0];
			}
		}
		
		$result = str_replace(
					$before,
					$after,
					$result);
		
		update_post_meta($id, "revision", $status. ','. $result);
	}

?>
